function d = mydet(A)

n = size(A,1);

% Rekursion endet bei 1x1 Matrix
if n == 1
    d = A;
    return
end

% Spalte und Zeile mit am meisten Nullen
[nz_col, best_col] = max(sum(A == 0, 1));
[nz_row, best_row] = max(sum(A == 0, 2));

% Falls mehr Nullen in einer Zeile, transponiere
if nz_col >= nz_row
    k = best_col;
else
    k = best_row;
    A = A';
end

% Entwicklung nach k-ter Spalte
c = zeros(1,n);
% Indizes der benoetigten Kofaktoren
indices = find(A(:,k))';
for i = indices
    Ai = A([1:(i-1) (i+1):end], [1:(k-1) (k+1):end]);
    c(i) = (-1)^(i+k) * mydet(Ai);
end
d = c*A(:,k);
